#include <vector>

#include "MatToVec.h"

MatToVec::MatToVec() {
  W = H = 0;
}

void MatToVec::SetMatrix(vector<vector<int>>& mat) {
  M = mat;
  W = (int)M.size();
  H = (int)M[0].size();
}

void MatToVec::SetVector(vector<int>& vec) {
  Y = vec;
}

void MatToVec::InitTemporalM() {
  if (T.size() != 0) {
    for (int i = 0; i < T.size(); i++) {
      T[i].clear();
    }

    T.clear();
  }

  T.resize(W);
  int k;

  for (k = 0; k < W; k++) {
    T[k].resize(H);
  }
}

void MatToVec::ScanLine() {
  V.clear();
  V.resize(W * H);
  int x, y;
  int i = 0;

  for (y = 0; y < H; y++) {
    for (x = 0; x < W; x++) {
      V[i++] = M[x][y];
    }
  }
}

int MatToVec::DeScanLine() {
  InitTemporalM();

  int x, y;
  int i = 0;

  for (y = 0; y < H; y++) {
    for (x = 0; x < W; x++) {
      T[x][y] = Y[i++];
    }
  }

  if (T == M) {
    return 1;
  }

  return 0;
}