#include "MwISimple.h"
#pragma warning (disable : 4996)

MwISimple::MwISimple()
{
	I.clear();
	O.clear();
	lowerBound = upperBound = 0;
}


void  MwISimple::Init(int d, int l, int h, int frst)
{
	lowerBound = l;
	upperBound = h;
	FirstEl = frst;
	delta = d;

	ABCSize = h - l + 1;
	ABC.resize(ABCSize);
	SetABC(frst);
}


void MwISimple::SetABC(int middle)
{
	ABC[0] = middle;
	int abcIndex = 1;
	int lBFlag = 1;
	int uBFlag = 1;

	int u = middle + 1;
	int l = middle - 1;

	while ((lBFlag) || (uBFlag))
	{
		if (uBFlag)
		{
			ABC[abcIndex++] = u++;
			if (u > upperBound)
				uBFlag = 0;				
		}

		if (lBFlag)
		{
			ABC[abcIndex++] = l--;

			if (l < lowerBound) 
				lBFlag = 0;				
		}
	}
}

int MwISimple::GetPosition(int v)
{
	int i = 0;

	while (v != ABC[i])
		i++;

	return i;
}


void MwISimple::MoveToFront(int p)
// p = position
{
	int a = ABC[p];

	for (int i = p - 1; i >= 0; i--)
		ABC[i + 1] = ABC[i];

	ABC[0] = a;
}


vector<int> MwISimple::DoWmISimple(vector<int>& A)
{
	int position;
	I = A;
	n = (int)I.size();
	O.resize(n);
	int oi = 0;
	for (int i = 0; i < n; i++)
	{	
		position = GetPosition(I[i]);

		O[oi++] = position;
		if (position != 0)
		{
			if (position > delta)
				SetABC(I[i]);
			else
				MoveToFront(position);
		}

	}
	return O;
}


/*
vector<int> MwISimple::DoMwIWav(vector<int> Inp, int d)
{
	delta = d;
	I = Inp;
	FirstEl = I[0];
	O.push_back(FirstEl);
	DetermineElements();

	SetABC(FirstEl);

	int position;

	for (int i = 1; i < I.size(); i++) // the value of the first element is known so we start at 1.
	{
		//	PrintABC(I[i]);
	//	if (i % 100 == 0)
		//	printf("%d\n", i);
		position = GetPosition(I[i]);
		O.push_back(position);
		if (position != 0)
		{
			if (position > delta)
				SetABC(I[i]);
			else
				MoveToFront(position);
		}
	}
	return O;
}
*/