package gemma;

import java.util.Vector;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;

public class AuxCompFunctions {

  public static Vector<Integer> DoVectorStatistic(Vector<Integer> V) {
    Vector<AtomicInteger> Statistics = new Vector<>();
    if (V.size() > 0) {
      int i;
      int max = 0;
      int min = 1000000;

      for (i = 0; i < V.size(); i++) {
        if (max < V.get(i)) {
          max = V.get(i);
        }

        if (min > V.get(i)) {
          min = V.get(i);
        }
      }

      if (min != 0) {
        for (i = 0; i < V.size(); i++) {
          V.set(i, V.get(i) - min);
        }
      }

      int NoOfElements = max - min + 1;

      for (i = 0; i < NoOfElements; i++) {
        Statistics.add(new AtomicInteger(0));
      }

      for (i = 0; i < V.size(); i++) {
        Statistics.get(V.get(i)).incrementAndGet();
      }
    }
    return new Vector<>(Statistics.stream().map(i -> i.intValue()).collect(Collectors.toList()));
  }

  public static Vector<Integer> DoMatrixStatistic(
      int Height, int Width, Vector<Vector<Integer>> M) {
    Vector<AtomicInteger> Statistics = new Vector<>();
    if (M.size() > 0) {
      int i, j;
      int max = 0;

      for (j = 0; j < Height; j++) {
        for (i = 0; i < Width; i++) {
          if (max < M.get(i).get(j)) max = M.get(i).get(j);
        }
      }

      max++;

      for (i = 0; i < max; i++) {
        Statistics.add(new AtomicInteger(0));
      }

      for (j = 0; j < Height; j++) {
        for (i = 0; i < Width; i++) {
          Statistics.get(M.get(i).get(j)).incrementAndGet();
        }
      }
    }
    return new Vector<>(Statistics.stream().map(i -> i.intValue()).collect(Collectors.toList()));
  }

  public static double CalculateEntropy(Vector<Integer> A) {

    int m = (int) A.size();

    int sum = 0;
    for (int i = 0; i < m; i++) sum += A.get(i);

    double h = 0.0;
    double a, b;
    for (int i = 0; i < m; i++) {
      if (A.get(i) != 0) {
        a = (double) A.get(i) / (double) sum;
        b = Math.log(a) / Math.log(2.0);
        h = h + a * b;
      }
    }
    return -h;
  }

  public static double CalculateStandardDeviation(Vector<Integer> V) {
    int i = 0;
    double average = 0;

    for (i = 0; i < V.size(); i++) average += V.get(i);

    average = (double) (average / ((double) V.size()));

    double d;
    double Sigma2 = 0;
    for (i = 0; i < V.size(); i++) {
      d = V.get(i) - average;
      Sigma2 += d * d;
    }

    Sigma2 = (double) (Sigma2 / ((double) V.size()));
    double Sigma = Math.sqrt(Sigma2);
    return Sigma;
  }
}
